Index: libstdc++-v3/include/bits/basic_string.h
===================================================================
--- libstdc++-v3/include/bits/basic_string.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/basic_string.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -2767,10 +2767,9 @@
    *
    *  Stores characters from @a __is into @a __str until @a __delim is
    *  found, the end of the stream is encountered, or str.max_size()
-   *  is reached.  If is.width() is non-zero, that is the limit on the
-   *  number of characters stored into @a __str.  Any previous
-   *  contents of @a __str are erased.  If @a __delim was encountered,
-   *  it is extracted but not stored into @a __str.
+   *  is reached.  Any previous contents of @a __str are erased.  If
+   *  @a __delim is encountered, it is extracted but not stored into
+   *  @a __str.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
     basic_istream<_CharT, _Traits>&
@@ -2785,10 +2784,9 @@
    *
    *  Stores characters from is into @a __str until &apos;\n&apos; is
    *  found, the end of the stream is encountered, or str.max_size()
-   *  is reached.  If __is.width() is non-zero, that is the limit on
-   *  the number of characters stored into @a __str.  Any previous
-   *  contents of @a __str are erased.  If end of line was
-   *  encountered, it is extracted but not stored into @a __str.
+   *  is reached.  Any previous contents of @a __str are erased.  If
+   *  end of line is encountered, it is extracted but not stored into
+   *  @a __str.
    */
   template<typename _CharT, typename _Traits, typename _Alloc>
     inline basic_istream<_CharT, _Traits>&
Index: libstdc++-v3/include/bits/stl_vector.h
===================================================================
--- libstdc++-v3/include/bits/stl_vector.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/stl_vector.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1184,7 +1184,11 @@
 			    _InputIterator __last, std::input_iterator_tag)
         {
 	  for (; __first != __last; ++__first)
+#if __cplusplus >= 201103L
+	    emplace_back(*__first);
+#else
 	    push_back(*__first);
+#endif
 	}
 
       // Called by the second initialize_dispatch above
Index: libstdc++-v3/include/bits/deque.tcc
===================================================================
--- libstdc++-v3/include/bits/deque.tcc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/bits/deque.tcc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -381,7 +381,11 @@
         __try
           {
             for (; __first != __last; ++__first)
+#if __cplusplus >= 201103L
+	      emplace_back(*__first);
+#else
               push_back(*__first);
+#endif
           }
         __catch(...)
           {
Index: libstdc++-v3/include/Makefile.am
===================================================================
--- libstdc++-v3/include/Makefile.am	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/include/Makefile.am	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1131,6 +1131,7 @@
 	sed -e '/^#pragma/b' \
 	    -e '/^#/s/\(${uppercase}${uppercase}*\)/_GLIBCXX_\1/g' \
 	    -e 's/_GLIBCXX_SUPPORTS_WEAK/__GXX_WEAK__/g' \
+	    -e 's/_GLIBCXX___MINGW32_GLIBCXX___/__MINGW32__/g' \
 	    -e 's,^#include "\(.*\)",#include <bits/\1>,g' \
 	    < $< > $@
 
Index: libstdc++-v3/ChangeLog
===================================================================
--- libstdc++-v3/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,118 @@
+2013-05-21  Jonathan Wakely  <jwakely.gcc@gmail.com>
+
+	PR libstdc++/57336
+	* include/std/functional (__invoke): Do not form function types with
+	abstract return type.
+	* testsuite/20_util/reference_wrapper/invoke-3.cc: New.
+
+2013-05-15  Jonathan Wakely  <jwakely.gcc@gmail.com>
+
+	* include/bits/basic_string.h (getline): Fix doxygen comments.
+
+2013-05-14  Evgeniy Stepanov  <eugenis@google.com>
+
+	* src/c++11/system_error.cc (generic_category_instance): Add
+	initializer.
+	(system_category_instance): Likewise.
+	* src/c++11/future.cc (__fec): Likewise.
+
+2013-05-08  Andoni Morales Alastruey <ylatuya@gmail.com>
+
+	PR libstdc++/57212
+	* include/Makefile.am (_GLIBCXX___MINGW32_GLIBCXX___): Modify
+	to __MINGW32__.
+	* include/Makefile.in: Regenerated.
+
+2013-04-27  François Dumont  <fdumont@gcc.gnu.org>
+
+	* include/bits/hashtable_policy.h
+	(_Insert_base<>::insert<_It>(_It, _It)): Enable move semantics.
+	* testsuite/23_containers/unordered_set/insert/move_range.cc: New.
+
+2013-04-22  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR libstdc++/57010
+	* include/bits/stl_heap.h (pop_heap): Avoid self move-assignment.
+	* testsuite/25_algorithms/pop_heap/57010.cc: New.
+
+2013-04-09  Tom Tromey  <tromey@redhat.com>
+
+	* configure, config.h.in: Rebuild.
+	* configure.ac: Use GLIBCXX_CHECK_SDT_H.  Don't check for
+	sys/sdt.h.
+	* acinclude.m4 (GLIBCXX_CHECK_SDT_H): New defun.
+
+2013-04-04  Gerald Pfeifer  <gerald@pfeifer.com>
+
+	* doc/xml/manual/allocator.xml: Adjust link to Dr.Dobb's article.
+
+	* doc/xml/manual/appendix_contributing.xml: Adjust link to GNU
+	Coding Standards.
+
+	* doc/xml/manual/debug.xml: Adjust link for ThreadSanitizer.
+
+	* doc/xml/manual/debug_mode.xml: Adjust link for SafeSTL.
+
+	* doc/xml/manual/documentation_hacking.xml: Adjust Doxygen link.
+
+	* doc/xml/manual/messages.xml: Adjust link to Java API specs.
+
+	* doc/xml/manual/policy_data_structures: Remove direct link to
+	IBM Haifa Research Labs.
+
+	* doc/xml/manual/policy_data_structures_biblio.xml: Adjust links
+	for biblio.maverik_lowerbounds and biblio.nelson96stlpq.
+
+	* doc/xml/manual/profile_mode.xml: Adjust two links to acm.org
+	papers.
+
+	* doc/xml/manual/shared_ptr.xml: Use canonical address for
+	www.boost.org.
+
+2013-04-03  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR libstdc++/56834
+	* include/debug/array (tuple_size, tuple_element): Do not declare.
+	* include/profile/array: Likewise.
+	* testsuite/23_containers/array/tuple_interface/
+	tuple_element_debug_neg.cc: Adjust dg-error line number.
+
+2013-03-27  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR libstdc++/55977 (partial, std::vector and std::deque bits)
+	* include/bits/stl_vector.h (_M_range_initialize(_InputIterator,
+	_InputIterator, std::input_iterator_tag)): Use emplace_back.
+	* include/bits/deque.tcc (_M_range_initialize(_InputIterator,
+	_InputIterator, std::input_iterator_tag)): Likewise.
+	* testsuite/23_containers/vector/cons/55977.cc: New.
+	* testsuite/23_containers/deque/cons/55977.cc: Likewise.
+	* testsuite/23_containers/vector/requirements/dr438/assign_neg.cc:
+	Adjust dg-error line number.
+	* testsuite/23_containers/vector/requirements/dr438/insert_neg.cc:
+	Likewise.
+
+2013-03-27  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR libstdc++/55979
+	* include/bits/stl_list.h (_M_initialize_dispatch(_InputIterator,
+	_InputIterator, __false_type)): Use emplace_back.
+	* testsuite/23_containers/list/cons/55979.cc: New.
+	* testsuite/23_containers/list/modifiers/1.h: Adjust.
+	* testsuite/23_containers/list/requirements/dr438/assign_neg.cc:
+	Adjust dg-error line number.
+
+2013-03-24  Jonathan Wakely  <jwakely.gcc@gmail.com>
+
+	PR libstdc++/56002
+	* include/std/mutex (lock_guard, unique_lock, lock): Define without
+	depending on _GLIBCXX_HAS_GTHREADS.
+	* testsuite/30_threads/lock_guard/cons/1.cc: Run on all targets.
+
+2013-03-22  Paolo Carlini  <paolo.carlini@oracle.com>
+
+	PR libstdc++/56678
+	* include/std/chrono (__is_ratio): Uglify T.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
Index: libstdc++-v3/testsuite/25_algorithms/pop_heap/57010.cc
===================================================================
--- libstdc++-v3/testsuite/25_algorithms/pop_heap/57010.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/25_algorithms/pop_heap/57010.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,55 @@
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-options "-std=gnu++11" }
+
+#include <algorithm>
+#include <functional>
+#include <testsuite_hooks.h>
+#include <testsuite_iterators.h>
+#include <testsuite_rvalref.h>
+
+using __gnu_test::test_container;
+using __gnu_test::random_access_iterator_wrapper;
+using __gnu_test::rvalstruct;
+
+typedef test_container<rvalstruct, random_access_iterator_wrapper> container;
+
+void test01()
+{
+  {
+    rvalstruct makeheap[1];
+    container makecon(makeheap, makeheap + 1);
+
+    std::push_heap(makecon.begin(), makecon.end());
+    std::pop_heap(makecon.begin(), makecon.end());
+  }
+
+  {
+    rvalstruct makeheap[1];
+    container makecon(makeheap, makeheap + 1);
+
+    std::push_heap(makecon.begin(), makecon.end(), std::less<rvalstruct>());
+    std::pop_heap(makecon.begin(), makecon.end(), std::less<rvalstruct>());
+  }
+}
+
+int main()
+{
+  test01();
+  return 0;
+}
Index: libstdc++-v3/testsuite/30_threads/lock_guard/cons/1.cc
===================================================================
--- libstdc++-v3/testsuite/30_threads/lock_guard/cons/1.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/30_threads/lock_guard/cons/1.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,9 +1,6 @@
-// { dg-do run { target *-*-freebsd* *-*-netbsd* *-*-linux* *-*-solaris* *-*-cygwin *-*-darwin* powerpc-ibm-aix* } }
-// { dg-options " -std=gnu++0x -pthread" { target *-*-freebsd* *-*-netbsd* *-*-linux* powerpc-ibm-aix* } }
-// { dg-options " -std=gnu++0x -pthreads" { target *-*-solaris* } }
-// { dg-options " -std=gnu++0x " { target *-*-cygwin *-*-darwin* } }
+// { dg-do run }
+// { dg-options " -std=gnu++11 " }
 // { dg-require-cstdint "" }
-// { dg-require-gthreads "" }
 
 // Copyright (C) 2010-2013 Free Software Foundation, Inc.
 //
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/assign_neg.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -18,7 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
-// { dg-error "no matching" "" { target *-*-* } 1236 }
+// { dg-error "no matching" "" { target *-*-* } 1240 }
 
 #include <vector>
 
Index: libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/23_containers/vector/requirements/dr438/insert_neg.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -18,7 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
-// { dg-error "no matching" "" { target *-*-* } 1277 }
+// { dg-error "no matching" "" { target *-*-* } 1281 }
 
 #include <vector>
 
Index: libstdc++-v3/testsuite/23_containers/vector/cons/55977.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/vector/cons/55977.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/23_containers/vector/cons/55977.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,60 @@
+// { dg-do compile }
+// { dg-options "-std=gnu++11" }
+
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <memory>
+#include <utility>
+#include <vector>
+#include <iterator>
+
+template <class T>
+struct MyAllocator
+{
+  std::allocator<T> base;
+  typedef T value_type;
+  MyAllocator() = default;
+  template <class U>
+  MyAllocator(const MyAllocator<U>& other) : base(other.base) {}
+  T* allocate(std::size_t n) { return base.allocate(n); }
+  void deallocate(T* p, std::size_t n) { return base.deallocate(p, n); }
+  template <class U, class... Args>
+  void construct(U* p, Args&&... args)
+  {
+    ::new (static_cast<void*>(p)) U(std::forward<Args>(args)...);
+  }
+};
+
+struct A
+{
+private:
+  friend class MyAllocator<A>;
+  A(int value) : value(value) {}
+  int value;
+public:
+  A() : value() {}
+  int get() const { return value; }
+};
+
+void foo()
+{
+  std::vector<A, MyAllocator<A>> v1;
+  const int i = 1;
+  v1.emplace_back(i); // OK
+  std::vector<A, MyAllocator<A>> v2(std::istream_iterator<int>(), {}); // ERROR
+}
Index: libstdc++-v3/testsuite/23_containers/unordered_set/insert/move_range.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_set/insert/move_range.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/23_containers/unordered_set/insert/move_range.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,51 @@
+// { dg-options "-std=gnu++11" }
+
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// range insert using move iterator
+
+#include <iterator>
+#include <vector>
+#include <unordered_set>
+#include <testsuite_hooks.h>
+#include <testsuite_counter_type.h>
+
+bool test __attribute__((unused)) = true;
+
+void test01()
+{
+  using namespace __gnu_test;
+
+  std::vector<counter_type> ref = { 0, 1, 2, 3, 4, 5 };
+  typedef std::unordered_set<counter_type, counter_type_hasher> Set;
+  Set s;
+
+  counter_type::reset();
+
+  s.insert(std::make_move_iterator(ref.begin()),
+	   std::make_move_iterator(ref.end()));
+
+  VERIFY( s.size() == ref.size() );
+  VERIFY( counter_type::move_count == ref.size() );
+}
+
+int main()
+{
+  test01();
+  return 0;
+}
Index: libstdc++-v3/testsuite/23_containers/deque/cons/55977.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/deque/cons/55977.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/23_containers/deque/cons/55977.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,70 @@
+// { dg-do compile }
+// { dg-options "-std=gnu++11" }
+
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <memory>
+#include <utility>
+#include <deque>
+#include <iterator>
+
+template <class T>
+struct MyAllocator
+{
+  std::allocator<T> base;
+  typedef T         value_type;
+
+  // FIXME: these types shouldn't be required.
+  typedef T*        pointer;
+  typedef const T*  const_pointer;
+  typedef T&        reference;
+  typedef const T&  const_reference;
+  template <typename U>
+    struct rebind
+    { typedef MyAllocator<U> other; };
+
+  MyAllocator() = default;
+  template <class U>
+  MyAllocator(const MyAllocator<U>& other) : base(other.base) {}
+  T* allocate(std::size_t n) { return base.allocate(n); }
+  void deallocate(T* p, std::size_t n) { return base.deallocate(p, n); }
+  template <class U, class... Args>
+  void construct(U* p, Args&&... args)
+  {
+    ::new (static_cast<void*>(p)) U(std::forward<Args>(args)...);
+  }
+};
+
+struct A
+{
+private:
+  friend class MyAllocator<A>;
+  A(int value) : value(value) {}
+  int value;
+public:
+  A() : value() {}
+  int get() const { return value; }
+};
+
+void foo()
+{
+  std::deque<A, MyAllocator<A>> v1;
+  const int i = 1;
+  v1.emplace_back(i); // OK
+  std::deque<A, MyAllocator<A>> v2(std::istream_iterator<int>(), {}); // ERROR
+}
Index: libstdc++-v3/testsuite/23_containers/list/modifiers/1.h
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/modifiers/1.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/23_containers/list/modifiers/1.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -89,14 +89,22 @@
   b = list0301.begin();
   list0301.insert(b, A, A + N); // should be [321 322 333 13 13]
   VERIFY(list0301.size() == 5);
+#if __cplusplus >= 201103L
+  VERIFY(copy_constructor::count() == 0);
+#else
   VERIFY(copy_constructor::count() == 3);
+#endif
   VERIFY(m->id() == 13);
 
   // range fill at end
   value_type::reset();
   list0301.insert(e, A, A + N); // should be [321 322 333 13 13 321 322 333]
   VERIFY(list0301.size() == 8);
+#if __cplusplus >= 201103L
+  VERIFY(copy_constructor::count() == 0);
+#else
   VERIFY(copy_constructor::count() == 3);
+#endif
   VERIFY(e == list0301.end());
   VERIFY(m->id() == 13);
 
@@ -104,7 +112,11 @@
   value_type::reset();
   list0301.insert(m, A, A + N);
   VERIFY(list0301.size() == 11);
+#if __cplusplus >= 201103L
+  VERIFY(copy_constructor::count() == 0);
+#else
   VERIFY(copy_constructor::count() == 3);
+#endif
   VERIFY(e == list0301.end());
   VERIFY(m->id() == 13);
 
Index: libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/23_containers/list/requirements/dr438/assign_neg.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -18,7 +18,7 @@
 // <http://www.gnu.org/licenses/>.
 
 // { dg-do compile }
-// { dg-error "no matching" "" { target *-*-* } 1525 }
+// { dg-error "no matching" "" { target *-*-* } 1529 }
 
 #include <list>
 
Index: libstdc++-v3/testsuite/23_containers/list/cons/55979.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/list/cons/55979.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/23_containers/list/cons/55979.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,34 @@
+// { dg-do compile }
+// { dg-options "-std=gnu++11" }
+
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <list>
+
+struct A
+{
+  A(int) { }
+  A(const A&) = delete;
+  A& operator=(const A&) = delete;
+};
+
+void foo()
+{
+  int i[] = {1, 2};
+  std::list<A> li(i, i + 2);
+}
Index: libstdc++-v3/testsuite/23_containers/array/tuple_interface/tuple_element_debug_neg.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/array/tuple_interface/tuple_element_debug_neg.cc	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/testsuite/23_containers/array/tuple_interface/tuple_element_debug_neg.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -23,4 +23,4 @@
 
 typedef std::tuple_element<1, std::array<int, 1>>::type type;
 
-// { dg-error "static assertion failed" "" { target *-*-* } 306 }
+// { dg-error "static assertion failed" "" { target *-*-* } 300 }
Index: libstdc++-v3/testsuite/20_util/reference_wrapper/invoke-3.cc
===================================================================
--- libstdc++-v3/testsuite/20_util/reference_wrapper/invoke-3.cc	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ libstdc++-v3/testsuite/20_util/reference_wrapper/invoke-3.cc	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,37 @@
+// { dg-options "-std=gnu++11" }
+// { dg-do compile }
+
+// Copyright (C) 2013 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// 20.8.3.4 reference_wrapper invocation [refwrap.invoke]
+#include <functional>
+
+struct ABC
+{
+    virtual bool operator()() const = 0;
+};
+
+struct Concrete : ABC
+{
+    virtual bool operator()() const { return true; }
+};
+
+Concrete c;
+ABC& abc = c;
+
+auto b = std::cref(abc)();
Index: libstdc++-v3/config.h.in
===================================================================
--- libstdc++-v3/config.h.in	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/config.h.in	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -400,7 +400,7 @@
 /* Define to 1 if you have the <sys/resource.h> header file. */
 #undef HAVE_SYS_RESOURCE_H
 
-/* Define to 1 if you have the <sys/sdt.h> header file. */
+/* Define to 1 if you have a suitable <sys/sdt.h> header file */
 #undef HAVE_SYS_SDT_H
 
 /* Define to 1 if you have the <sys/sem.h> header file. */
Index: libstdc++-v3/acinclude.m4
===================================================================
--- libstdc++-v3/acinclude.m4	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libstdc++-v3/acinclude.m4	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -3660,6 +3660,36 @@
 ])
 
 
+dnl
+dnl Check to see if sys/sdt.h exists and that it is suitable for use.
+dnl Some versions of sdt.h were not compatible with C++11.
+dnl
+AC_DEFUN([GLIBCXX_CHECK_SDT_H], [
+  AC_MSG_RESULT([for suitable sys/sdt.h])
+  # Note that this test has to be run with the C language.
+  # Otherwise, sdt.h will try to include some headers from
+  # libstdc++ itself.
+  AC_LANG_SAVE
+  AC_LANG_C
+  AC_CACHE_VAL(glibcxx_cv_sys_sdt_h, [
+    # Because we have to run the test in C, we use grep rather
+    # than the compiler to check for the bug.  The bug is that
+    # were strings without trailing whitespace, causing g++
+    # to look for operator"".  The pattern searches for the fixed
+    # output.
+    AC_EGREP_CPP([ \",\" ], [
+      #include <sys/sdt.h>
+      int f() { STAP_PROBE(hi, bob); }
+    ], [glibcxx_cv_sys_sdt_h=yes], [glibcxx_cv_sys_sdt_h=no])
+  ])
+  AC_LANG_RESTORE
+  if test $glibcxx_cv_sys_sdt_h = yes; then
+    AC_DEFINE(HAVE_SYS_SDT_H, 1,
+              [Define to 1 if you have a suitable <sys/sdt.h> header file])
+  fi
+  AC_MSG_RESULT($glibcxx_cv_sys_sdt_h)
+])
+
 # Macros from the top-level gcc directory.
 m4_include([../config/gc++filt.m4])
 m4_include([../config/tls.m4])
Index: boehm-gc/include/Makefile.am
===================================================================
--- boehm-gc/include/Makefile.am	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ boehm-gc/include/Makefile.am	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-AUTOMAKE_OPTIONS = foreign
+AUTOMAKE_OPTIONS = foreign no-dist
 
 noinst_HEADERS = gc.h gc_backptr.h gc_local_alloc.h \
   gc_pthread_redirects.h gc_cpp.h
Index: boehm-gc/ChangeLog
===================================================================
--- boehm-gc/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ boehm-gc/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,13 @@
+2013-03-22  Jakub Jelinek  <jakub@redhat.com>
+
+	PR other/43620
+	* Makefile.am (AUTOMAKE_OPTIONS): Add no-dist.
+	* include/Makefile.am (AUTOMAKE_OPTIONS): Add no-dist.
+	* testsuite/Makefile.am (AUTOMAKE_OPTIONS): Add no-dist.
+	* Makefile.in: Regenerated.
+	* include/Makefile.in: Regenerated.
+	* testsuite/Makefile.in: Regenerated.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
Index: boehm-gc/testsuite/Makefile.am
===================================================================
--- boehm-gc/testsuite/Makefile.am	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ boehm-gc/testsuite/Makefile.am	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,6 +1,6 @@
 ## Process this file with automake to produce Makefile.in.
 
-AUTOMAKE_OPTIONS = foreign dejagnu
+AUTOMAKE_OPTIONS = foreign dejagnu no-dist
 
 EXPECT = expect
 
Index: boehm-gc/Makefile.am
===================================================================
--- boehm-gc/Makefile.am	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ boehm-gc/Makefile.am	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -4,7 +4,7 @@
 ## files that should be in the distribution are not mentioned in this
 ## Makefile.am.
 
-AUTOMAKE_OPTIONS = foreign subdir-objects
+AUTOMAKE_OPTIONS = foreign subdir-objects no-dist
 ACLOCAL_AMFLAGS = -I .. -I ../config
 
 SUBDIRS = include testsuite
Index: include/ChangeLog
===================================================================
--- include/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ include/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,10 @@
+2013-04-03  Jason Merrill  <jason@redhat.com>
+
+	Demangle C++11 ref-qualifier.
+	* demangle.h (enum demangle_component_type): Add
+	DEMANGLE_COMPONENT_REFERENCE_THIS,
+	DEMANGLE_COMPONENT_RVALUE_REFERENCE_THIS.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
Index: include/demangle.h
===================================================================
--- include/demangle.h	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ include/demangle.h	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -302,6 +302,12 @@
   /* The const qualifier modifying a member function.  The one subtree
      is the type which is being qualified.  */
   DEMANGLE_COMPONENT_CONST_THIS,
+  /* C++11 A reference modifying a member function.  The one subtree is the
+     type which is being referenced.  */
+  DEMANGLE_COMPONENT_REFERENCE_THIS,
+  /* C++11: An rvalue reference modifying a member function.  The one
+     subtree is the type which is being referenced.  */
+  DEMANGLE_COMPONENT_RVALUE_REFERENCE_THIS,
   /* A vendor qualifier.  The left subtree is the type which is being
      qualified, and the right subtree is the name of the
      qualifier.  */
Index: libiberty/ChangeLog
===================================================================
--- libiberty/ChangeLog	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ libiberty/ChangeLog	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,3 +1,17 @@
+2013-04-03  Jason Merrill  <jason@redhat.com>
+
+	Demangle C++11 ref-qualifier.
+	* cp-demangle.c (d_ref_qualifier): New.
+	(d_nested_name, d_function_type): Use it.
+	(d_parmlist): Don't get confused by a ref-qualifier.
+	(cplus_demangle_type): Reorder ref-qualifier.
+	(d_pointer_to_member_type): Likewise.
+	(d_dump): Handle DEMANGLE_COMPONENT_REFERENCE_THIS and
+	DEMANGLE_COMPONENT_RVALUE_REFERENCE_THIS.
+	(d_make_comp, has_return_type, d_encoding): Likewise.
+	(d_print_comp, d_print_mod_list, d_print_mod): Likewise.
+	(d_print_function_type, is_ctor_or_dtor): Likewise.
+
 2013-03-22  Release Manager
 
 	* GCC 4.8.0 released.
